commit 44e3cee5d12238feae07d809f7affe7a730ddfb1
Author: freddy77 <freddy77>
Date:   Wed Sep 10 11:37:05 2008 +0000

    avoid useless buffer allocations

diff --git a/ChangeLog b/ChangeLog
index 1a10362..35488f2 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+Wed Sep 10 13:36:48 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/odbc.c src/odbc/sql2tds.c:
+	- avoid useless buffer allocations
+
 Wed Sep 10 13:19:53 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tdsodbc.h src/odbc/odbc.c src/odbc/odbc_util.c:
 	* src/odbc/prepare_query.c src/odbc/sql2tds.c:
@@ -629,4 +633,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2604 2008/09/10 11:22:24 freddy77 Exp $
+$Id: ChangeLog,v 1.2605 2008/09/10 11:37:05 freddy77 Exp $
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 05a52c2..e4bce55 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -60,7 +60,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.492 2008/09/10 11:22:34 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.493 2008/09/10 11:37:06 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv);
@@ -975,11 +975,6 @@ odbc_build_update_params(TDS_STMT * stmt, unsigned int n_row)
                 params = temp_params;
 
 		curcol = params->columns[params->num_cols - 1];
-		if (!tds_alloc_param_data(curcol)) {
-			tds_free_param_results(params);
-			odbc_errs_add(&stmt->errs, "HY001", NULL);
-			return NULL;
-		}
 		tds_strlcpy(curcol->column_name, tds_dstr_cstr(&drec_ird->sql_desc_name), sizeof(curcol->column_name));
 		curcol->column_namelen = strlen(curcol->column_name);
 
diff --git a/src/odbc/sql2tds.c b/src/odbc/sql2tds.c
index 82fc484..9fbcb84 100644
--- a/src/odbc/sql2tds.c
+++ b/src/odbc/sql2tds.c
@@ -52,7 +52,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sql2tds.c,v 1.73 2008/09/10 11:22:36 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sql2tds.c,v 1.74 2008/09/10 11:37:08 freddy77 Exp $");
 
 static TDS_INT
 convert_datetime2server(int bindtype, const void *src, TDS_DATETIME * dt)
@@ -289,6 +289,15 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 		}
 	}
 
+	/* set NULL. For NULLs we don't need to allocate row buffer so avoid it */
+	if (!need_data) {
+		assert(drec_ipd->sql_desc_parameter_type != SQL_PARAM_OUTPUT || sql_len == SQL_NULL_DATA);
+		if (sql_len == SQL_NULL_DATA) {
+			curcol->column_cur_size = -1;
+			return SQL_SUCCESS;
+		}
+	}
+
 	/* allocate given space */
 	if (!tds_alloc_param_data(curcol)) {
 		odbc_errs_add(&stmt->errs, "HY001", NULL);
@@ -300,13 +309,6 @@ sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _drecord
 		return SQL_NEED_DATA;
 	}
 
-	/* set null */
-	assert(drec_ipd->sql_desc_parameter_type != SQL_PARAM_OUTPUT || sql_len == SQL_NULL_DATA);
-	if (sql_len == SQL_NULL_DATA) {
-		curcol->column_cur_size = -1;
-		return SQL_SUCCESS;
-	}
-
 	if (!src) {
 		odbc_errs_add(&stmt->errs, "HY090", NULL);
 		return SQL_ERROR;

